cordova.define("cordova-plugin-ucsoe.UCSOEPlugin", function(require, exports, module) {
               
               var argscheck = require('cordova/argscheck'),
               utils = require('cordova/utils'),
               exec = require('cordova/exec');

               var mediaObjects = {};
    
var UCSOEPlugin = function (startCallback,dataCallback,errorCallback,statusCallback) {
    this.id = utils.createUUID();
    mediaObjects[this.id] = this;
    this.startCallback = startCallback;
    this.dataCallback = dataCallback;
    this.errorCallback = errorCallback;
    this.statusCallback = statusCallback;
     exec(null, this.errorCallback, "UCSOEPlugin", "create", [this.id]);
}

// channel messages
UCSOEPlugin.RECORD_STATE = 1;

UCSOEPlugin.prototype.start = function (param) {
    exec(this.startCallback, this.errorCallback, "UCSOEPlugin", "start", [param]);
}

UCSOEPlugin.prototype.stop = function () {
    exec(this.dataCallback, this.errorCallback, "UCSOEPlugin", "stop", null);
}
               
UCSOEPlugin.prototype.cancel = function () {
    exec(null, this.errorCallback, "UCSOEPlugin", "cancel", null);
}

UCSOEPlugin.prototype.result = function (successResultCallback, errorResultCallback, correctIds) {
    exec(successResultCallback, errorResultCallback, "UCSOEPlugin", "result", [correctIds]);
}

UCSOEPlugin.onStatus = function(id, msgType, value) {

    var media = mediaObjects[id];

    if (media) {
        switch(msgType) {
            case UCSOEPlugin.RECORD_STATE :
                if (media.statusCallback) {
                    media.statusCallback(value);
                }
                break;
            default :
                if (console.error) {
                    console.error("Unhandled UCSOEPlugin.onStatus :: " + msgType);
                }
                break;
        }
    } else if (console.error) {
        console.error("Received UCSOEPlugin.onStatus callback for unknown media :: " + id);
    }

};


module.exports = UCSOEPlugin;

function onMessageFromNative(msg) {
    if (msg.action == 'status') {
        UCSOEPlugin.onStatus(msg.status.id, msg.status.msgType, msg.status.value);
    } else {
        throw new Error('Unknown media action' + msg.action);
    }
}

if (cordova.platformId === 'android' || cordova.platformId === 'amazon-fireos' || cordova.platformId === 'windowsphone') {

    var channel = require('cordova/channel');

    channel.createSticky('onUCSOEPluginReady');
    channel.waitForInitialization('onUCSOEPluginReady');

    channel.onCordovaReady.subscribe(function() {
        exec(onMessageFromNative, undefined, 'UCSOEPlugin', 'messageChannel', []);
        channel.initializationComplete('onUCSOEPluginReady');
    });
}


});
